# frozen_string_literal: true

module GoNative
  module Utils
    class TemplateInflator
      def initialize(content)
        @content = content.dup
      end
  
      def call(values)
        values.each { |name, value| content.gsub!("{{#{name}}}", value.to_s) }
    
        content
      end
  
      private
      
      attr_reader :content
    end
  end
end
